# Link to task: https://leetcode.com/problems/remove-duplicates-from-sorted-array/
from typing import List

class Solution:
    def removeDuplicates(self, nums: List[int]) -> int:
        if len(nums) <= 1:
            return 0
        unique, iteratror, real_pose = 1, 1, 0
        while iteratror < len(nums):
            if nums[real_pose] != nums[iteratror]:
                unique += 1
                real_pose += 1
                nums[real_pose] = nums[iteratror]
            iteratror += 1
        return unique


if __name__ == "__main__":
    # nums = [1, 1, 2]
    nums = [0,0,1,1,1,2,2,3,3,4]
    print(Solution().removeDuplicates(nums))
    print(nums)
