from typing import List, Optional


class ListNode:
    def __init__(self, val=0, next=None):
        self.val = val
        self.next = next


class Solution:
    def reorderList(self, head: Optional[ListNode]) -> None:
        nodes: List[ListNode] = []
        sorted_nodes: List[ListNode] = []
        while head:
            nodes.append(head)
            head = head.next
        right = len(nodes) - 1
        left = 0
        counter = 0
        while left <= right:
            if counter % 2 == 0:
                sorted_nodes.append(nodes[left])
                left += 1
            else:
                sorted_nodes.append(nodes[right])
                right -= 1
            counter += 1
        for sni in range(0, len(sorted_nodes) - 1):
            sorted_nodes[sni].next = sorted_nodes[sni + 1]
        sorted_nodes[-1].next = None
        return sorted_nodes[0]


if __name__ == "__main__":
    s = Solution()
    e3 = ListNode(8, None)
    e2 = ListNode(6, e3)
    e1 = ListNode(4, e2)
    e0 = ListNode(2, e1)
    fe = s.reorderList(e0)
    while fe:
        print(f"{fe.val}")
        fe = fe.next
