# Task
Reverse Linked List
Given the beginning of a singly linked list head, reverse the list, and return the new beginning of the list.

Example 1:

Input: head = [0,1,2,3]

Output: [3,2,1,0]
Example 2:

Input: head = []

Output: []
Constraints:

0 <= The length of the list <= 1000.
-1000 <= Node.val <= 1000

# Solution
## 0
ll = [0, 1, 2, 3]
p = None
c = 0
n = 1

## 1
 p
 c   
    n  
[0, 1, 2, 3]

```
if p == c
    p.next = None
    c = n
    n = c.next
```

## 2
 p
    c
       n 
[0, 1, 2, 3]
```
c.next = p
p = c
c = n
n = c.next
```

## 3
    p
       c
          n
[0, 1, 2, 3]
```
c.next = p
p = c
c = n
n = c.next
```
## 4
       p
          c
             n = None
[0, 1, 2, 3]

